
// Network Pong game
// Written by Dr. Ev'L Schemm

#include <iostream> 
using namespace std;

#include <stdlib.h> // atoi
#include <string.h> // strcpy

#include "SDL.h"
#include "SDL_thread.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include "snet.h"

#include <stdio.h>


int imserver;    // Whether this instance is the game server or client



#define PORTNUM 11223

#define BOT 420

class GameData
  {
public:
  
  int stop;                 // Server top
  int ctop;                 // Client top
  int ssize;                // Size of server bar
  int csize;                // Size of client bar
  int x;                    // x position of ball
  int y;                    // y position of ball
  int dx;                   // x speed of ball
  int dy;                   // y speed of ball
  int client_score;         // client_score
  int server_score;         // server_score

  GameData();
  };

GameData::GameData()
  {
  ctop = 100;
  stop = 100;
  ssize = 50;
  csize = 50;
  x = 300;
  y = 100;
  dx = -2;
  dy = -2;
  client_score = 0;
  server_score = 0;
  }
  
GameData gamedata;

extern "C"
{



void pack_gamedata(unsigned char* buffer)
  {
  SNET_pack_int(&buffer[0], gamedata.ctop);
  SNET_pack_int(&buffer[4], gamedata.stop);
  SNET_pack_int(&buffer[8], gamedata.ssize);
  SNET_pack_int(&buffer[12], gamedata.csize);
  SNET_pack_int(&buffer[16], gamedata.x);
  SNET_pack_int(&buffer[20], gamedata.y);
  SNET_pack_int(&buffer[24], gamedata.dx);
  SNET_pack_int(&buffer[28], gamedata.dy);
  SNET_pack_int(&buffer[32], gamedata.client_score);
  SNET_pack_int(&buffer[36], gamedata.server_score);
  }


void unpack_gamedata(unsigned char* buffer)
  {
  gamedata.ctop = SNET_unpack_int(&buffer[0]);
  gamedata.stop = SNET_unpack_int(&buffer[4]);
  gamedata.ssize = SNET_unpack_int(&buffer[8]);
  gamedata.csize = SNET_unpack_int(&buffer[12]);
  gamedata.x = SNET_unpack_int(&buffer[16]);
  gamedata.y = SNET_unpack_int(&buffer[20]);
  gamedata.dx = SNET_unpack_int(&buffer[24]);
  gamedata.dy = SNET_unpack_int(&buffer[28]);
  gamedata.client_score = SNET_unpack_int(&buffer[32]);
  gamedata.server_score = SNET_unpack_int(&buffer[36]);
  }
  
}
//  Buffer Size = 40 bytes

SDL_mutex* packer;


SDL_Surface * screen;
int screen_flags;

TTF_Font *font;

  
void change_screen(int x, int y)
  {
  screen = SDL_SetVideoMode(x, y, 32, screen_flags);
  if (screen == NULL)
    {
    fprintf(stderr, "Error changing screen mode: %s\n", SDL_GetError());
    exit(1);
    }
  }


void xprint(char* str,TTF_Font* font, int x, int y)
  {
  SDL_Surface *temp;
  SDL_Rect loc;
  SDL_Color color={255,255,255};
  int w, h;

  temp = TTF_RenderText_Solid(font, str, color);

  loc.x = x; loc.y = y; TTF_SizeText(font, str, &w, &h);
  loc.w = w; loc.h = h;

  SDL_BlitSurface(temp, NULL, screen, &loc);
  
  SDL_FreeSurface(temp);
  }


void init_SDL_stuff()
  {
  FILE* file;
  
  int numtimesopened, frequency, channels;
  Uint16 format;
  
  
  if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER)==-1))
    {
    printf("Could not initialize SDL: %s.\n", SDL_GetError());
    exit(-1);
    }
  /* Clean up on exit */
  

  TTF_Init();

  
  atexit(TTF_Quit);
  atexit(SDL_Quit);
  
  
  // Make the initial version of the main screen
  screen_flags = SDL_SWSURFACE | SDL_SRCCOLORKEY;
  change_screen(640, 480);
  
  
  
  SDL_WM_SetCaption("Network Pong I", "Network Pong I");

  font = TTF_OpenFont("origa___.ttf", 48);
  if (!font) {printf("TTF_OpenFont: %s\n", TTF_GetError());}

  } 

void MoveBall()
  {
  // Move ball by dx,dy
  gamedata.x += gamedata.dx;
  gamedata.y += gamedata.dy;
  
  // Check for Top bounce
  if (gamedata.y <= 5)
    {
    gamedata.dy *= -1;
    while (gamedata.y < 5)
      {
      gamedata.x += gamedata.dx;
      gamedata.y += gamedata.dy;
      }
    }
  // Check for bottom Bounce
  if (gamedata.y >= (BOT-5))
    {
    gamedata.dy *= -1;
    while (gamedata.y > (BOT-5))
      {
      gamedata.x += gamedata.dx;
      gamedata.y += gamedata.dy;
      }
    }
  
  // Left Bounce or score
  if (gamedata.x <= 15)
    {
    if ((gamedata.y >= gamedata.stop) && 
	(gamedata.y < (gamedata.stop+gamedata.ssize)))
      {
      gamedata.dx *= -1;
      while (gamedata.x <= 15)
	{
	gamedata.x += gamedata.dx;
	gamedata.y += gamedata.dy;
	}	
      }
    if (gamedata.x <= 5)
      {
      // Score one for the server player!
      gamedata.client_score += 1;
      
      // Reset ball;
      gamedata.x = 300;
      gamedata.y = 100;
      gamedata.dx = -2;
      gamedata.dy = -2;
      }
    }
  
  if (gamedata.x >= 610)
    {
    if ((gamedata.y >= gamedata.ctop) && 
	(gamedata.y < (gamedata.ctop+gamedata.csize)))
      {
      gamedata.dx *= -1;
      while (gamedata.x >= 610)
	{
	gamedata.x += gamedata.dx;
	gamedata.y += gamedata.dy;
	}	
      }
    if (gamedata.x >= 630)
      {
      // Score one for the client player!
      gamedata.server_score += 1;
      
      // Reset ball;
      gamedata.x = 300;
      gamedata.y = 100;
      gamedata.dx = -2;
      gamedata.dy = -2;
      }
    }
  
  }


void UpdateScreen()
  {
  SDL_Rect changes[20];
  SDL_Surface*score;

  char str[10];
  SDL_Color color={255,255,255};

  
  changes[0].x = 0; changes[0].y = 0; changes[0].w = 640; changes[0].h = 480;
  SDL_FillRect(screen, &changes[0], SDL_MapRGB(screen->format, 0,0,0));
  
  changes[1].x = 5; changes[1].y = gamedata.stop; changes[1].w = 10; 
  changes[1].h = gamedata.ssize ;
  SDL_FillRect(screen, &changes[1], SDL_MapRGB(screen->format, 255,255,255));
  
  changes[2].x = 615; changes[2].y = gamedata.ctop; changes[2].w = 10; 
  changes[2].h = gamedata.csize ;
  SDL_FillRect(screen, &changes[2], SDL_MapRGB(screen->format, 255,255,255));
  
  changes[3].x = gamedata.x; changes[3].y = gamedata.y; changes[3].w = 5;
  changes[3].h = 5;
  SDL_FillRect(screen, &changes[3], SDL_MapRGB(screen->format, 255,255,255));




  sprintf(str, "%02d", gamedata.server_score);
  score = TTF_RenderText_Solid(font, str, color);
  changes[4].x = 10; changes[4].y = 430; changes[4].w = 100; changes[4].h = 45;
  SDL_BlitSurface(score, NULL, screen, &changes[4]);

  SDL_FreeSurface(score);




  sprintf(str, "%02d", gamedata.client_score);
  score = TTF_RenderText_Solid(font, str, color);
  changes[5].x = 539; changes[5].y = 430; changes[5].w = 100; changes[5].h =45;
  SDL_BlitSurface(score, NULL, screen, &changes[5]);
  
  SDL_FreeSurface(score);
  
  SDL_UpdateRects(screen, 6, changes);
  
    
  }

void handle_endgame()
  {
  SDL_Event event;

  // Need to post a message
  xprint("CONNECTION LOST!", font, 13, 100);
  SDL_UpdateRect(screen,0,0,0,0);
  // Allow for SDL_Quit or ESC
    // Handle SDL_Quit Event
  while (1)
    {
    while (SDL_PollEvent(&event) > 0)
      {
      switch(event.type)
	{
	case SDL_QUIT:
	  return;
	case SDL_KEYDOWN:
	  if (event.key.keysym.sym == SDLK_ESCAPE)
	    return;
	}
      } // SDL_Quit Event poll
    }
  }

int main(int argc, char* argv[])
  {
  SDL_Event event;
  SDL_TimerID draw_timer;
  Uint8 *keystate;
  
  Uint16 clientnum;
  Uint16 whofrom;
  Uint16 cmd;
  Uint32 data;
  

  SNet_Server *server;
  SNet_Client *client;
  
  // Init screen;
  init_SDL_stuff();

  packer = SDL_CreateMutex();

  // pong.exe -s 127.0.0.1


  // Figure out if I am the server or client
  if (argc == 3) 
	{
	// Client
	imserver = 0;
	client = SNET_InitClient(argv[2], PORTNUM);
	if (client == NULL)
	  {
	  cout << "Unable to create client!" << endl;
	  exit(1);
	  }
	SNET_ClientRegisterHandler(client, 1, pack_gamedata, unpack_gamedata,
				   40, packer);
	SNET_StartClient(client);
	}
  else
	{
  	imserver = 1;
	server = SNET_InitServer(PORTNUM, 1); // 1 client only!
	if (server == NULL)
	  {
	  cout << "Unable to create server!" << endl;
	  exit(1);
	  }

	SNET_ServerRegisterHandler(server, 1, pack_gamedata, unpack_gamedata,
				   40, packer);

	SNET_StartServer(server);

	xprint("NO CLIENT YET!", font, 60, 100);
	SDL_UpdateRect(screen, 0,0,0,0);

	// Need to wait for client to connect
	while (SNET_PollServer(server, &cmd, &data, &clientnum) == -1) 
	  {
	  SDL_Delay(1);
	  while (SDL_PollEvent(&event) > 0)
	    {
	    switch(event.type)
	      {
	      case SDL_QUIT:
		exit(0);
	      case SDL_KEYDOWN:
		if (event.key.keysym.sym == SDLK_ESCAPE)
		  exit(0);
	      }
	    } // SDL_Quit Event poll
	  }
	}




  while (1)
    {      
      SDL_Delay(1);           
      SDL_PumpEvents();

      keystate = SDL_GetKeyState(NULL);

      if (keystate[SDLK_UP])
	{
	if (imserver == 1)
	  {
	  SDL_LockMutex(packer);
	  gamedata.stop -= 2;
	  if (gamedata.stop < 0) gamedata.stop = 0;
	  SDL_UnlockMutex(packer);
	  }
	else
	  {
	  SNET_SendCmdToServer(client, 10, 0);
	  }
	}
      if (keystate[SDLK_DOWN])
	{
	if (imserver == 1)
	  {
	  SDL_LockMutex(packer);
	  gamedata.stop += 2;
	  if ((gamedata.stop + gamedata.ssize) > BOT) 
	    gamedata.stop = BOT- gamedata.ssize;
	  SDL_UnlockMutex(packer);
	  }
	else
	  {
	  SNET_SendCmdToServer(client, 11, 0);
	  }
	}
      
      if (keystate[SDLK_EQUALS])
	{
	if (imserver == 1)
	  {
	  SDL_LockMutex(packer);
	  if ((gamedata.stop + gamedata.ssize) < BOT)
	    gamedata.ssize++;
	  SDL_UnlockMutex(packer);
	  }
	else
	  {
	  SNET_SendCmdToServer(client, 12, 0);
	  }
	}
	
      if (keystate[SDLK_MINUS])
	{
	if (imserver == 1)
	  {
	  SDL_LockMutex(packer);
	  if (gamedata.ssize > 1)
	    gamedata.ssize--;
	  SDL_UnlockMutex(packer);
	  }
	else
	  {
	  SNET_SendCmdToServer(client, 13, 0);
	  }
	}
      
      if (keystate[SDLK_ESCAPE])
	{
	handle_endgame();
	exit(0);
	}
      
      
      // Handle SDL_Quit Event
      while (SDL_PollEvent(&event) > 0)
        {
        switch(event.type)
          {
          case SDL_QUIT:
            exit(0);
          }
        } // SDL_Quit Event poll

      if (!imserver)  // Client should check for a disconnect packet too!
	{
	while (SNET_PollClient(client, &cmd, &data) != -1)
	  {
	  if (cmd == 0)  // All we care about is a disconnect packet!
	    {
	    handle_endgame();
	    exit(0);
	    }
	  }
	}


      if (imserver)   // Things the server does that the client does not
	{
	// Check for incoming commands
	while (SNET_PollServer(server, &cmd, &data, &whofrom) != -1)
	  {
	  if (whofrom == clientnum)
	    {
	    if (cmd == 0)   // Client disconnect!
	      {
	      handle_endgame();
	      exit(0);
	      }

	    if (cmd == 10)
	      {
	      SDL_LockMutex(packer);
	      gamedata.ctop -= 2;
	      if (gamedata.ctop < 0) gamedata.ctop = 0;
	      SDL_UnlockMutex(packer);
	      }
	    if (cmd == 11)
	      {
	      SDL_LockMutex(packer);
	      gamedata.ctop += 2;
	      if ((gamedata.ctop + gamedata.csize) > BOT) 
		gamedata.ctop = BOT- gamedata.csize;
	      SDL_UnlockMutex(packer);
	      }
	    if (cmd == 12)
	      {
	      SDL_LockMutex(packer);
	      if ((gamedata.ctop + gamedata.csize) < BOT)
		gamedata.csize++;
	      SDL_UnlockMutex(packer);
	      }
	    if (cmd == 13)
	      {
	      SDL_LockMutex(packer);
	      if (gamedata.csize > 1) gamedata.csize--;
	      SDL_UnlockMutex(packer);
	      }
	    }
	  }
	  SDL_LockMutex(packer);
	  MoveBall();
	  SDL_UnlockMutex(packer);
	  SNET_SendDataToClient(server, clientnum, 1);
	}
       
	// Update Display
      UpdateScreen();
      
    } // While 1
  
  } // Main


